=== debian/changelog ===
secvarctl (1.1.0-0ubuntu1) plucky; urgency=low
 
  * Initial release v1.1.0 (LP: #2064345)

 -- Patricia Domingues <patricia.domingues@canonical.com>  Wed, 12 Feb 2025 18:11:09 -0300
