=== debian/control ===
Source: secvarctl
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: 
 cmake, 
 debhelper-compat (= 13),
 gnutls-bin,
 libssl-dev,
 python3,
Standards-Version: 4.7.0
Homepage: https://github.com/open-power/secvarctl

Package: secvarctl
Architecture: ppc64el amd64                                                                            
Depends: 
 ${shlibs:Depends},
 ${misc:Depends},
Description: To manipulate and generate Secure Boot variables on POWER
 x86 works for file generation and validation.
 Suite of tools to manipulate and generate Secure Boot variables on POWER.
