=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ # make

override_dh_install:
	rm -f debian/tmp/usr/share/doc/secvarctl/copyright
