=== debian/watch ===
version=4                                                                                                                                                     
https://github.com/open-power/secvarctl/tags .*/v?(\d.*)\.(?:tgz|tbz2|tar\.(?:gz|bz2|xz))
